routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

Route::resource('alumno', AlumnoController::class);
Route::resource('curso', CursoController::class);
Route::resource('practica', PracticaController::class);
Route::resource('pertenece', PerteneceController::class);
Route::resource('presenta', PresentaController::class);


// Enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('/practica/confirmar/{practica}', 'confirmar')->name('practica.confirmar');
});

// Enrutamiento adicional para Pertenece
Route::controller(PerteneceController::class)->group(function () {
    Route::get('/pertenece/confirmar/{pertenece}', 'confirmar')->name('pertenece.confirmar');
});

// Enrutamiento adicional para Presenta
Route::controller(PresentaController::class)->group(function () {
    Route::get('/presenta/confirmar/{presenta}', 'confirmar')->name('presenta.confirmar');
});

app/Models/Curso.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Schema;

class Curso extends Model {
    use HasFactory;

    protected $table = 'cursos';

    // Campos de asignación masiva
    protected $fillable = [
        'nombre',
        'duracion',
        'fechacomienzo',
        'observaciones',
    ];

    // Nombre de los campos  de las tablas
    public static $labels = [
        'id' => 'ID Curso',
        'nombre' => 'Nombre Curso',
        'duracion' => 'Duración Curso',
        'fechacomienzo' => 'Fecha Comienzo Curso',
        'observaciones' => 'Observaciones Curso',
    ];

    /**
     ** Recupera la lista de campos de la tabla asociada al modelo.
     *
     * @return array La lista de nombres de campos.
    */
    public function getFields(): array {
        return Schema::getColumnListing($this->table);
    }

    /**
     ** Recupera la etiqueta de un atributo dado.
     *
     * @param string $attribute El nombre del atributo.
     * @return string La etiqueta del atributo, o el nombre del atributo si no se encuentra una etiqueta.
    */
    public function getAttributeLabel($attribute): string {
        return self::$labels[$attribute] ?? $attribute;
    }

    /**
     ** Obtiene la lista de campos de la modelo de tabla asociada.
     *
     * @return array|HasMany La lista de nombres de campos asociados a Practica.
    */
    public function practicas() : HasMany {
        return $this->hasMany(Practica::class);
    }

    /**
     ** Obtiene la lista de campos de la modelo de tabla asociada.
     *
     * @return array|HasMany La lista de nombres de campos asociados a Pertenece.
    */
    public function perteneces() : HasMany {
        return $this->hasMany(Pertenece::class);
    }
}

app/Http/Controllers/CursoController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CursoStoreRequest;
use App\Http\Requests\CursoUpdateRequest;
use App\Models\Curso;
use Illuminate\Http\Request;

class CursoController extends Controller {
    /**
     * Display a listing of the resource.
     */
    public function index() {
        $cursos = Curso::all();

        return view('curso.index', compact('cursos'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create() {
        return view('curso.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CursoStoreRequest $request) {
        $curso = Curso::create($request->all());

        return redirect()
            ->route('curso.show', $curso)
            ->with('mensaje', 'Curso se ha creado con éxito')
        ;
    }

    /**
     * Display the specified resource.
    */
    public function show(Curso $curso) {
        return view('curso.show', compact('curso'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Curso $curso) {
        return view('curso.edit', compact('curso'));
    }

    /**
     * Update the specified resource in storage.
    */
    public function update(CursoUpdateRequest $request, Curso $curso) {
        $curso->update($request->all());

        return redirect()
            ->route('curso.show', $curso)
            ->with('mensaje', 'Curso actualizado con éxito')
        ;
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Curso $curso) {
        $curso->delete();

        return redirect()
            ->route('curso.index')
            ->with('mensaje', 'Curso borrado con éxito')
        ;
    }
}

resources/views/curso/create.blade.php
@extends('layouts.main')

@section('content')
    <h1>Crear Curso</h1>

    @if ($errors->any())
        <div class="">
            <div class="" style="">
                <h2 class="">Error</h2>

                @foreach ($errors->all() as $error)
                    <p class=""> {{ $error }} </p>
                @endforeach
            </div>
        </div>
    @endif

    <a href="{{ route('curso.index') }}" class="boton">Volver</a>

    <form action="{{ route('curso.store') }}" method="POST"  enctype="multipart/form-data">
        @csrf

        <div>
            <label for="nombre">Nombre</label>
            <input type="text" name="nombre" id="nombre">
        </div>

        <div>
            <label for="duracion">Duracion</label>
            <input type="number" name="duracion" id="duracion">
        </div>

        <div>
            <label for="fechacomienzo">Fecha de Comienzo</label>
            <input type="date" name="fechacomienzo" id="fechacomienzo">
        </div>

        <div>
            <label for="observaciones">Observaciones</label>
            <input type="text" name="observaciones" id="observaciones">
        </div>

        <div>
            <button class="boton" type="submit">Crear</button>
        </div>
    </form>
@endsection

resources/views/curso/edit.blade.php
@extends('layouts.main')

@section('content')
    <h1>Editar Curso</h1>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p class="">{{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    @if ($errors->any())
        <div class="">
            <div class="" style="background-color: gray">
                <h2 class="">Error</h2>
                @foreach ($errors->all() as $error)
                    <p class=""> {{ $error }} </p>
                @endforeach
            </div>
        </div>
    @endif

    <br><a href="{{ route('curso.index') }}" class="boton">Volver</a>

    <form action="{{ route('curso.update', $curso) }}" method="POST"  enctype="multipart/form-data">
        @csrf
        @method('PUT')

        <div>
            <label for="nombre">Nombre</label>
            <input type="text" name="nombre" id="nombre" value="{{ old('nombre', $curso->nombre) }}">
        </div>

        <div>
            <label for="duracion">Duracion</label>
            <input type="number" name="duracion" id="duracion" value="{{ old('duracion', $curso->duracion) }}">
        </div>

        <div>
            <label for="fechacomienzo">Fecha de Comienzo</label>
            <input type="date" name="fechacomienzo" id="fechacomienzo" value="{{ old('fechacomienzo', $curso->fechacomienzo) }}">
        </div>

        <div>
            <label for="observaciones">Observaciones</label>
            <input type="text" name="observaciones" id="observaciones" value="{{ old('observaciones', $curso->observaciones) }}">
        </div>

        <div>
            <button class="boton" type="submit">Actualizar</button>
        </div>
    </form>
@endsection

resources/views/curso/index.blade.php
@extends('layouts.main')

@section('content')
    <h1>Listado Curso</h1>

    <div>
        <a href="{{ route('curso.create') }}" class="boton">Crear Curso</a><br>
    </div>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    <div class="listado">
        @foreach ($cursos as $curso)
            <div class="tarjeta">
                <ul>
                    <li><a href="{{ route('curso.show', $curso) }}" >ID:</a> {{ $curso->id }}</li>
                    <li>Nombre: {{ $curso->nombre }}</li>
                    <li>Duracion: {{ $curso->duracion }}</li>
                    <li>Fecha Comienzo: {{ $curso->fechacomienzo }}</li>
                    <li>Observaciones: {{ $curso->observaciones }}</li>
                </ul>

                <div class="botones">
                    <a class="boton" href="{{ route('curso.show', $curso) }}">Ver</a>
                    <a class="boton" href="{{ route('curso.edit', $curso) }}">Editar</a>

                    <form action="{{ route('curso.destroy', $curso)}}" method="POST" id="eliminar">
                        @csrf @method('DELETE')
                        <button class="boton" type="submit">Borrar</button>
                    </form>
                </div>
            </div>
        @endforeach
    </div>
@endsection

resources/views/curso/show.blade.php
@extends('layouts.main')

@section('content')
    <h1>Listado Cursos</h1>

    <div>
        <a href="{{ route('curso.index') }}" class="boton">Volver</a><br><br>
    </div>

    @if (session('mensaje'))
        <div class="">
            <div class="" style="background-color: gray">
                <p> {{ session('mensaje') }} </p>
            </div>
        </div>
    @endif

    <div class="tarjeta">
        <ul>
            <li>ID: {{ $curso->id }}</li>
            <li>Nombre: {{ $curso->nombre }}</li>
            <li>Duracion: {{ $curso->duracion }}</li>
            <li>Fecha Comienzo: {{ $curso->fechacomienzo }}</li>
            <li>Observaciones: {{ $curso->observaciones }}</li>
        </ul>

        <div class="botones">
            <a class="boton" href="{{ route('curso.edit', $curso) }}">Editar</a>

            <form action="{{ route('curso.destroy', $curso)}}" method="POST" id="eliminar">
                @csrf @method('DELETE')
                <button type="submit">Borrar</button>
            </form><br><br>
        </div>
    </div>
@endsection